#!/usr/bin/python
import sys
import vxi11
import time
import numpy as np

log_name = "dcl_10vdc_hulk_34401a_nplc100.csv"

fluke = vxi11.Instrument("192.168.1.125", "gpib0,1") # Fluke 5720A, GPIB Address = 1
fluke.timeout = 30
#fluke.clear()
fluke.write("*IDN?")
print "Source detected = %s" % fluke.read()

dmm = vxi11.Instrument("192.168.1.125", "gpib0,8") # Keysight 3458A, GPIB Address = 1
dmm.timeout = 30
dmm.clear()
dmm.write("*IDN?")
print "DUT Detected = %s" % dmm.read()

fluke.write("RANGELCK OFF")
fluke.write("OUT 10.0 V, 0 Hz")
fluke.write("RANGELCK ON")
fluke.write("STBY")
fluke.write("OUT 0.0 V, 0 Hz")
fluke.write("EXTGUARD ON")
fluke.write("OPER")
time.sleep(2)
print "SRC configured"
dmm.write("*RST")
dmm.write(":STAT:PRES")
dmm.write(":INP:IMP:AUTO ON")
dmm.write(":SENS:ZERO:AUTO ON")
dmm.write(":SENS:FUNC 'VOLT:DC'")
dmm.write(":SENS:VOLT:DC:RES MIN")
dmm.write(":SENS:VOLT:DC:RANG:AUTO OFF")
dmm.write(":SENS:VOLT:DC:NPLC 100")
dmm.write(":SENS:VOLT:DC:RANG 10")
#dmm.write("ACAL DCV")
#time.sleep(150)
for vcnt in range (0,5):
    dmm.write("READ?")
    dmm.read()
dmm.write("CALC:FUNC NULL")
dmm.write("CALC:STAT ON")
dmm.write("READ?")
dmm.read()
print "DUT is nulled to MFC zero"

with open(log_name, 'a') as dile:
    dile.write ("date;source;dut;temp;\r\n")
dile.close()

vcnt = 0 # temporary counter
print "Log into %s started" % log_name

for i in range(-109,110,1):
    median = 0.0
    sdev = 0.0
    array = []
    fluke.write("OUT %.7f" % (float(i) / 10))
    fluke.write("OPER")
    time.sleep(5)
    for ix in range (0,10): #take more samples
	dmm.write("READ?")
	val = float(dmm.read())
	array.extend([val])
	if abs(float(i) / 10) >= 0.05:
	    print("sample = %.8f, ppm dev = %.4f" % (val, ((val / (float(i)/10) - 1) * 1e6) ))
    	if (abs(val) >= 9.9e36):
	    print ("Smoke escaped, check connections")
	    fluke.write("OUT 0 V")
	    fluke.write("STBY")
	    quit()
    sdev = np.std(array[7:])
    median = np.median(array[7:])
    if abs(float(i) / 10) >= 0.05:
	print("SRC %.2f , latest sample = %.9f, sdev5 = %.3f uV, median5 = %.8f" % (float(i)/10, val, sdev*1e6, median))
        #dmm.write("DISP MSG,'%5.3f %2.1fV" % (((median / (float(i)/10) - 1) * 1e6),float(i)/10) )
    temp = 24
    with open(log_name, 'a') as dile:
        dile.write (time.strftime("%m%d%Y-%H:%M:%S;") + ("%.2f;%.9f;%.1f;\r\n" % (float(i)/10, median, temp)))
    dile.close()

fluke.write("OUT 0 V")
fluke.write("STBY")
fluke.write("RANGELCK OFF")
dmm.write("*RST")
